/******************************************************************************
//
//	File:		benaphore.h
//
//	Description:	A benaphore class
//
//	Copyright 1998, Joe Kloss
//
*******************************************************************************/

#ifndef BENAPHORE_H
#define BENAPHORE_H

#include <OS.h>

class Benaphore
{
	public:
		Benaphore( int32 threadCount, const char *name );
		~Benaphore( void );
		status_t Acquire( void );
		status_t Acquire( uint32 count, uint32 flags, bigtime_t timeout );
		status_t Release( void );
		status_t Release( uint32 count, uint32 flags );
		
	private:
		int32		previous;
		sem_id		sem;
		int32		ben_val;
};

#endif